/*
 * Signal.h
 *
 *  Created on: Jun 6, 2011
 *      Author: "bhufmann"
 */

#ifndef SIGNAL_H_
#define SIGNAL_H_

#include "common_signal.h"
#include <string.h>

class Signal
{
public:
    Signal();
    Signal(SIGNAL_NUMBER sigNo, size_t size);
    Signal(char* name, size_t size );
    Signal(const Signal& other);
    Signal & operator= (const Signal & other);
    
    virtual ~Signal();
    
    inline SIGNAL* getSignal() { return reinterpret_cast<SIGNAL*>(mp_signal); }
    inline size_t getSize() { return m_size; }
    SIGNAL_NUMBER getSignalNumber();
    
    inline void setSignal(char *, size_t);

private:
    char* mp_signal;
    size_t  m_size;
};

inline void Signal::setSignal(char * bytes, size_t size) 
{
    if (mp_signal) delete[] mp_signal;

    mp_signal = new char[size];
    memcpy(mp_signal, &bytes[0], size);
    m_size = size;
}



#endif /* SIGNAL_H_ */
