/*
 * my_signal.h
 *
 *  Created on: Jun 6, 2011
 *      Author: "bhufmann"
 */

#ifndef MYSIGNAL_H_
#define MYSIGNAL_H_

#include "signal.h"

const uint32_t MY_SIGNAL_BASE           = 10000;

const uint32_t MY_REQUESTS              = MY_SIGNAL_BASE;
const uint32_t MY_NUMBER_OF_REQUESTS    = 100;

const uint32_t MY_REPLIES               = MY_REQUESTS + MY_NUMBER_OF_REQUESTS;
const uint32_t MY_NUMBER_OF_REPLIES     = 100;

enum
{
    REGISTER_PLAYER_REQUEST = MY_REQUESTS,
    GAME_REQUEST,
    START_GAME_REQUEST,
    BALL_REQUEST,
    PAUSE_GAME_REQUEST,
    RESUME_GAME_REQUEST,
    STOP_GAME_REQUEST, 
    DEREGISTER_PLAYER_REQUEST
};

enum
{
    REGISTER_PLAYER_REPLY = MY_REPLIES,
    GAME_REPLY,
    START_GAME_REPLY,
    BALL_REPLY,
    PAUSE_GAME_REPLY,
    RESUME_GAME_REPLY,
    STOP_GAME_REPLY, 
    DEREGISTER_PLAYER_REPLY
};

struct initReqest {
    SIGNAL_NUMBER sigNo;
};

enum GAMES 
{
    PLAY_BALL = 0
};

struct RegisterPlayerRequest {
    SIGNAL_NUMBER sigNo;
    char          player[1];
};

struct GameRequest {
    SIGNAL_NUMBER sigNo;
    GAMES         game;
};

struct StartGameRequest {
    SIGNAL_NUMBER sigNo;
};

struct BallRequest {
    SIGNAL_NUMBER sigNo;
    int           count;
};

struct PauseGameRequest {
    SIGNAL_NUMBER sigNo;
};

struct ResumeGameRequest {
    SIGNAL_NUMBER sigNo;
};

struct StopGameRequest {
    SIGNAL_NUMBER sigNo;
};

struct DeregisterPlayerRequest {
    SIGNAL_NUMBER sigNo;
    char          player[1];
};

struct RegisterPlayerReply {
    SIGNAL_NUMBER sigNo;
    bool          result;
};

struct GameReply {
    SIGNAL_NUMBER sigNo;
    bool          result;
};

struct StartGameReply {
    SIGNAL_NUMBER sigNo;
    bool          result;
};

struct BallReply {
    SIGNAL_NUMBER sigNo;
    bool          result;
    int           count;
};

struct PauseGameReply {
    SIGNAL_NUMBER sigNo;
    bool          result;
};

struct ResumeGameReply {
    SIGNAL_NUMBER sigNo;
    bool         result;
};

struct StopGameReply {
    SIGNAL_NUMBER sigNo;
    uint32_t      result;
};

struct DeregisterPlayerReply {
    SIGNAL_NUMBER sigNo;
    bool          result;
};

union SIGNAL
{
    SIGNAL_NUMBER           sigNo;
    RegisterPlayerRequest   registerPlayerRequest;
    GameRequest             gameRequest;
    StartGameRequest        startGameRequest;
    BallRequest             ballRequest;
    PauseGameRequest        pauseGameRequest;
    ResumeGameRequest       resumeGameRequest;
    StopGameRequest         stopGameRequest;
    DeregisterPlayerRequest deregisterPlayerRequest;
    RegisterPlayerReply     registerPlayerReply;
    GameReply               gameReply;      
    StartGameReply          startGameReply;
    BallReply               ballReply;
    PauseGameReply          pauseGameReply;
    ResumeGameReply         resumeGameReply;
    StopGameReply           stopGameReply;
    DeregisterPlayerReply   deregisterPlayerReply;
};


#endif /* MYSIGNAL_H_ */
