#undef TRACEPOINT_PROVIDER
#define TRACEPOINT_PROVIDER ust_sequence

#if !defined(TP_H_) || defined(TRACEPOINT_HEADER_MULTI_READ)
#define TP_H_
#ifdef __cplusplus
extern "C" {
#endif

#include <lttng/tracepoint.h>
#include <sys/types.h>

//**********************************************************************
// CONSTANTS AND TYPES DECLARATIONS
//**********************************************************************

TRACEPOINT_EVENT(ust_sequence, ENTER,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, RETURN,
	TP_ARGS(char *, file, int, line),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
	)
)

TRACEPOINT_EVENT(ust_sequence, INFO,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)


TRACEPOINT_EVENT(ust_sequence, ERROR,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE1,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE2,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE3,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE4,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE5,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE6,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE7,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE8,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, TRACE9,
	TP_ARGS(char *, file, int, line, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, SEND,
	TP_ARGS(char *, file, int, line, char *, sender, char *, receiver, int, signal, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(sender, sender)
		ctf_string(receiver, receiver)
		ctf_integer(int, signal, signal)
		ctf_string(content, content)
	)
)


TRACEPOINT_EVENT(ust_sequence, RECEIVE,
	TP_ARGS(char *, file, int, line, char *, sender, char *, receiver, int, signal, char *, content),
	TP_FIELDS(
		ctf_string(file, file)
		ctf_integer(int, line, line)
		ctf_string(sender, sender)
		ctf_string(receiver, receiver)
		ctf_integer(int, signal, signal)
		ctf_string(content, content)
	)
)

TRACEPOINT_EVENT(ust_sequence, before_fork,
	TP_ARGS(),
	TP_FIELDS()
)

TRACEPOINT_EVENT(ust_sequence, after_fork_child,
	TP_ARGS(pid_t, pid),
	TP_FIELDS(
		ctf_integer(pid_t, pid, pid)
	)
)

TRACEPOINT_EVENT(ust_sequence, after_fork_parent,
	TP_ARGS(),
	TP_FIELDS()
)

TRACEPOINT_EVENT(ust_sequence, after_exec,
	TP_ARGS(),
	TP_FIELDS()
)
        
#endif /* TP_H_ */

#undef TRACEPOINT_INCLUDE_FILE
#define TRACEPOINT_INCLUDE_FILE ./tp.h

/* This part must be outside ifdef protection */
#include <lttng/tracepoint-event.h>

#ifdef __cplusplus 
}
#endif
